﻿using System.Collections.Generic;

// Dicom Dictionary.
// Written by Amarnath S, Mahesh Reddy S, Bangalore, India, April 2009.
// This Dicom Dictionary does not contain all tags specified in Part 6 of the Standard,
// but contains most of the tags.

// Inspired heavily by ImageJ

namespace SARD
{
    class DicomDictionary
    {
        public Dictionary<string, string> dict = new Dictionary<string,string>()
        {
            {"20002", "UIMedia Storage SOP Class UID"}, 
            {"20003", "UIMedia Storage SOP Inst UID"},
            {"20010", "UITransfer Syntax UID"},
            {"20012", "UIImplementation Class UID"},
            {"20013", "SHImplementation Version Name"},
            {"20016", "AESource Application Entity Title"},
		
            {"80005", "CSSpecific Character Set"},
            {"80008", "CSImage Type"},
            {"80010", "CSRecognition Code"},
            {"80012", "DAInstance Creation Date"},
            {"80013", "TMInstance Creation Time"},
            {"80014", "UIInstance Creator UID"},
            {"80016", "UISOP Class UID"},
            {"80018", "UISOP Instance UID"},
            {"80020", "DAStudy Date"},
            {"80021", "DASeries Date"},
            {"80022", "DAAcquisition Date"},
            {"80023", "DAContent Date"},
            {"80024", "DAOverlay Date"},
            {"80025", "DACurve Date"},
            {"80030", "TMStudy Time"},
            {"80031", "TMSeries Time"},
            {"80032", "TMAcquisition Time"},
            {"80033", "TMContent Time"},
            {"80034", "TMOverlay Time"},
            {"80035", "TMCurve Time"},
            {"80041", "LOData Set Subtype"},
            {"80042", "CSNuclear Medicine Series Type"},
            {"80050", "SHAccession Number"},
            {"80052", "CSQuery/Retrieve Level"},
            {"80054", "AERetrieve AE Title"},
            {"80058", "AEFailed SOP Instance UID List"},
            {"80060", "CSModality"},
            {"80064", "CSConversion Type"},
            {"80068", "CSPresentation Intent Type"},
            {"80070", "LOManufacturer"},
            {"80080", "LOInstitution Name"},
            {"80081", "STInstitution Address"},
            {"80082", "SQInstitution Code Sequence"},
            {"80090", "PNReferring Physician's Name"},
            {"80092", "STReferring Physician's Address"},
            {"80094", "SHReferring Physician's Telephone Numbers"},
            {"80100", "SHCode Value"},
            {"80102", "SHCoding Scheme Designator"},
            {"80104", "LOCode Meaning"},
            {"80201", "SHTimezone Offset From UTC"},
            {"81010", "SHStation Name"},
            {"81030", "LOStudy Description"},
            {"81032", "SQProcedure Code Sequence"},
            {"8103E", "LOSeries Description"},
            {"81040", "LOInstitutional Department Name"},
            {"81048", "PNPhysician(s) of Record"},
            {"81050", "PNAttending Physician's Name"},
            {"81060", "PNName of Physician(s) Reading Study"},
            {"81070", "PNOperator's Name"},
            {"81080", "LOAdmitting Diagnosis Description"},
            {"81084", "SQAdmitting Diagnosis Code Sequence"},
            {"81090", "LOManufacturer's Model Name"},
            {"81100", "SQReferenced Results Sequence"},
            {"81110", "SQReferenced Study Sequence"},
            {"81111", "SQReferenced Study Component Sequence"},
            {"81115", "SQReferenced Series Sequence"},
            {"81120", "SQReferenced Patient Sequence"},
            {"81125", "SQReferenced Visit Sequence"},
            {"81130", "SQReferenced Overlay Sequence"},
            {"81140", "SQReferenced Image Sequence"},
            {"81145", "SQReferenced Curve Sequence"},
            {"81150", "UIReferenced SOP Class UID"},
            {"81155", "UIReferenced SOP Instance UID"},
            {"82111", "STDerivation Description"},
            {"82112", "SQSource Image Sequence"},
            {"82120", "SHStage Name"},
            {"82122", "ISStage Number"},
            {"82124", "ISNumber of Stages"},
            {"82129", "ISNumber of Event Timers"},
            {"82128", "ISView Number"},
            {"8212A", "ISNumber of Views in Stage"},
            {"82130", "DSEvent Elapsed Time(s)"},
            {"82132", "LOEvent Timer Name(s)"},
            {"82142", "ISStart Trim"},
            {"82143", "ISStop Trim"},
            {"82144", "ISRecommended Display Frame Rate"},
            {"82200", "CSTransducer Position"},
            {"82204", "CSTransducer Orientation"},
            {"82208", "CSAnatomic Structure"},

            {"100010", "PNPatient's Name"},
            {"100020", "LOPatient ID"},
            {"100021", "LOIssuer of Patient ID"},
            {"100030", "DAPatient's Birth Date"},
            {"100032", "TMPatient's Birth Time"},
            {"100040", "CSPatient's Sex"},
            {"101000", "LOOther Patient IDs"},
            {"101001", "PNOther Patient Names"},
            {"101005", "PNPatient's Maiden Name"},
            {"101010", "ASPatient's Age"},
            {"101020", "DSPatient's Size"},
            {"101030", "DSPatient's Weight"},
            {"101040", "LOPatient's Address"},
            {"102150", "LOCountry of Residence"},
            {"102152", "LORegion of Residence"},
            {"102180", "SHOccupation"},
            {"1021A0", "CSSmoking Status"},
            {"1021B0", "LTAdditional Patient History"},
            {"104000", "LTPatient Comments"},

            {"180010", "LOContrast/Bolus Agent"},
            {"180015", "CSBody Part Examined"},
            {"180020", "CSScanning Sequence"},
            {"180021", "CSSequence Variant"},
            {"180022", "CSScan Options"},
            {"180023", "CSMR Acquisition Type"},
            {"180024", "SHSequence Name"},
            {"180025", "CSAngio Flag"},
            {"180030", "LORadionuclide"},
            {"180031", "LORadiopharmaceutical"},
            {"180032", "DSEnergy Window Centerline"},
            {"180033", "DSEnergy Window Total Width"},
            {"180034", "LOIntervention Drug Name"},
            {"180035", "TMIntervention Drug Start Time"},
            {"180040", "ISCine Rate"},
            {"180050", "DSSlice Thickness"},
            {"180060", "DSkVp"},
            {"180070", "ISCounts Accumulated"},
            {"180071", "CSAcquisition Termination Condition"},
            {"180072", "DSEffective Series Duration"},
            {"180073", "CSAcquisition Start Condition"},
            {"180074", "ISAcquisition Start Condition Data"},
            {"180075", "ISAcquisition Termination Condition Data"},
            {"180080", "DSRepetition Time"},
            {"180081", "DSEcho Time"},
            {"180082", "DSInversion Time"},
            {"180083", "DSNumber of Averages"},
            {"180084", "DSImaging Frequency"},
            {"180085", "SHImaged Nucleus"},
            {"180086", "ISEcho Numbers(s)"},
            {"180087", "DSMagnetic Field Strength"},
            {"180088", "DSSpacing Between Slices"},
            {"180089", "ISNumber of Phase Encoding Steps"},
            {"180090", "DSData Collection Diameter"},
            {"180091", "ISEcho Train Length"},
            {"180093", "DSPercent Sampling"},
            {"180094", "DSPercent Phase Field of View"},
            {"180095", "DSPixel Bandwidth"},
            {"181000", "LODevice Serial Number"},
            {"181004", "LOPlate ID"},
            {"181010", "LOSecondary Capture Device ID"},
            {"181012", "DADate of Secondary Capture"},
            {"181014", "TMTime of Secondary Capture"},
            {"181016", "LOSecondary Capture Device Manufacturer"},
            {"181018", "LOSecondary Capture Device Manufacturer's Model Name"},
            {"181019", "LOSecondary Capture Device Software Version(s)"},
            {"181020", "LOSoftware Versions(s)"},
            {"181022", "SHVideo Image Format Acquired"},
            {"181023", "LODigital Image Format Acquired"},
            {"181030", "LOProtocol Name"},
            {"181040", "LOContrast/Bolus Route"},
            {"181041", "DSContrast/Bolus Volume"},
            {"181042", "TMContrast/Bolus Start Time"},
            {"181043", "TMContrast/Bolus Stop Time"},
            {"181044", "DSContrast/Bolus Total Dose"},
            {"181045", "ISSyringe Counts"},
            {"181050", "DSSpatial Resolution"},
            {"181060", "DSTrigger Time"},
            {"181061", "LOTrigger Source or Type"},
            {"181062", "ISNominal Interval"},
            {"181063", "DSFrame Time"},
            {"181064", "LOFraming Type"},
            {"181065", "DSFrame Time Vector"},
            {"181066", "DSFrame Delay"},
            {"181070", "LORadionuclide Route"},
            {"181071", "DSRadionuclide Volume"},
            {"181072", "TMRadionuclide Start Time"},
            {"181073", "TMRadionuclide Stop Time"},
            {"181074", "DSRadionuclide Total Dose"},
            {"181075", "DSRadionuclide Half Life"},
            {"181076", "DSRadionuclide Positron Fraction"},
            {"181080", "CSBeat Rejection Flag"},
            {"181081", "ISLow R-R Value"},
            {"181082", "ISHigh R-R Value"},
            {"181083", "ISIntervals Acquired"},
            {"181084", "ISIntervals Rejected"},
            {"181085", "LOPVC Rejection"},
            {"181086", "ISSkip Beats"},
            {"181088", "ISHeart Rate"},
            {"181090", "ISCardiac Number of Images"},
            {"181094", "ISTrigger Window"},
            {"181100", "DSReconstruction Diameter"},
            {"181110", "DSDistance Source to Detector"},
            {"181111", "DSDistance Source to Patient"},
            {"181120", "DSGantry/Detector Tilt"},
            {"181130", "DSTable Height"},
            {"181131", "DSTable Traverse"},
            {"181140", "CSRotation Direction"},
            {"181141", "DSAngular Position"},
            {"181142", "DSRadial Position"},
            {"181143", "DSScan Arc"},
            {"181144", "DSAngular Step"},
            {"181145", "DSCenter of Rotation Offset"},
            {"181146", "DSRotation Offset"},
            {"181147", "CSField of View Shape"},
            {"181149", "ISField of View Dimensions(s)"},
            {"181150", "ISExposure Time"},
            {"181151", "ISX-ray Tube Current"},
            {"181152", "ISExposure"},
            {"181153", "ISExposure in uAs"},
            {"181154", "DSAverage Pulse Width"},
            {"181155", "CSRadiation Setting"},
            {"181156", "CSRectification Type"},
            {"18115A", "CSRadiation Mode"},
            {"18115E", "DSImage Area Dose Product"},
            {"181160", "SHFilter Type"},
            {"181161", "LOType of Filters"},
            {"181162", "DSIntensifier Size"},
            {"181164", "DSImager Pixel Spacing"},
            {"181166", "CSGrid"},
            {"181170", "ISGenerator Power"},
            {"181180", "SHCollimator/grid Name"},
            {"181181", "CSCollimator Type"},
            {"181182", "ISFocal Distance"},
            {"181183", "DSX Focus Center"},
            {"181184", "DSY Focus Center"},
            {"181190", "DSFocal Spot(s)"},
            {"181191", "CSAnode Target Material"},
            {"1811A0", "DSBody Part Thickness"},
            {"1811A2", "DSCompression Force"},
            {"181200", "DADate of Last Calibration"},
            {"181201", "TMTime of Last Calibration"},
            {"181210", "SHConvolution Kernel"},
            {"181242", "ISActual Frame Duration"},
            {"181243", "ISCount Rate"},
            {"181250", "SHReceiving Coil"},
            {"181251", "SHTransmitting Coil"},
            {"181260", "SHPlate Type"},
            {"181261", "LOPhosphor Type"},
            {"181300", "ISScan Velocity"},
            {"181301", "CSWhole Body Technique"},
            {"181302", "ISScan Length"},
            {"181310", "USAcquisition Matrix"},
            {"181312", "CSPhase Encoding Direction"},
            {"181314", "DSFlip Angle"},
            {"181315", "CSVariable Flip Angle Flag"},
            {"181316", "DSSAR"},
            {"181318", "DSdB/dt"},
            {"181400", "LOAcquisition Device Processing Description"},
            {"181401", "LOAcquisition Device Processing Code"},
            {"181402", "CSCassette Orientation"},
            {"181403", "CSCassette Size"},
            {"181404", "USExposures on Plate"},
            {"181405", "ISRelative X-ray Exposure"},
            {"181450", "CSColumn Angulation"},
            {"181500", "CSPositioner Motion"},
            {"181508", "CSPositioner Type"},
            {"181510", "DSPositioner Primary Angle"},
            {"181511", "DSPositioner Secondary Angle"},
            {"181520", "DSPositioner Primary Angle Increment"},
            {"181521", "DSPositioner Secondary Angle Increment"},
            {"181530", "DSDetector Primary Angle"},
            {"181531", "DSDetector Secondary Angle"},
            {"181600", "CSShutter Shape"},
            {"181602", "ISShutter Left Vertical Edge"},
            {"181604", "ISShutter Right Vertical Edge"},
            {"181606", "ISShutter Upper Horizontal Edge"},
            {"181608", "ISShutter Lower Horizontal Edge"},
            {"181610", "ISCenter of Circular Shutter"},
            {"181612", "ISRadius of Circular Shutter"},
            {"181620", "ISVertices of the Polygonal Shutter"},
            {"181700", "ISCollimator Shape"},
            {"181702", "ISCollimator Left Vertical Edge"},
            {"181704", "ISCollimator Right Vertical Edge"},
            {"181706", "ISCollimator Upper Horizontal Edge"},
            {"181708", "ISCollimator Lower Horizontal Edge"},
            {"181710", "ISCenter of Circular Collimator"},
            {"181712", "ISRadius of Circular Collimator"},
            {"181720", "ISVertices of the Polygonal Collimator"},
            {"185000", "SHOutput Power"},
            {"185010", "LOTransducer Data"},
            {"185012", "DSFocus Depth"},
            {"185020", "LOPreprocessing Function"},
            {"185021", "LOPostprocessing Function"},
            {"185022", "DSMechanical Index"},
            {"185024", "DSThermal Index"},
            {"185026", "DSCranial Thermal Index"},
            {"185027", "DSSoft Tissue Thermal Index"},
            {"185028", "DSSoft Tissue-focus Thermal Index"},
            {"185029", "DSSoft Tissue-surface Thermal Index"},
            {"185050", "ISDepth of Scan Field"},
            {"185100", "CSPatient Position"},
            {"185101", "CSView Position"},
            {"185104", "SQProjection Eponymous Name Code Sequence"},
            {"185210", "DSImage Transformation Matrix"},
            {"185212", "DSImage Translation Vector"},
            {"186000", "DSSensitivity"},
            {"186011", "SQSequence of Ultrasound Regions"},
            {"186012", "USRegion Spatial Format"},
            {"186014", "USRegion Data Type"},
            {"186016", "ULRegion Flags"},
            {"186018", "ULRegion Location Min X0"},
            {"18601A", "ULRegion Location Min Y0"},
            {"18601C", "ULRegion Location Max X1"},
            {"18601E", "ULRegion Location Max Y1"},
            {"186020", "SLReference Pixel X0"},
            {"186022", "SLReference Pixel Y0"},
            {"186024", "USPhysical Units X Direction"},
            {"186026", "USPhysical Units Y Direction"},
            {"181628", "FDReference Pixel Physical Value X"},
            {"18602A", "FDReference Pixel Physical Value Y"},
            {"18602C", "FDPhysical Delta X"},
            {"18602E", "FDPhysical Delta Y"},
            {"186030", "ULTransducer Frequency"},
            {"186031", "CSTransducer Type"},
            {"186032", "ULPulse Repetition Frequency"},
            {"186034", "FDDoppler Correction Angle"},
            {"186036", "FDSterring Angle"},
            {"186038", "ULDoppler Sample Volume X Position"},
            {"18603A", "ULDoppler Sample Volume Y Position"},
            {"18603C", "ULTM-Line Position X0"},
            {"18603E", "ULTM-Line Position Y0"},
            {"186040", "ULTM-Line Position X1"},
            {"186042", "ULTM-Line Position Y1"},
            {"186044", "USPixel Component Organization"},
            {"186046", "ULPixel Component Mask"},
            {"186048", "ULPixel Component Range Start"},
            {"18604A", "ULPixel Component Range Stop"},
            {"18604C", "USPixel Component Physical Units"},
            {"18604E", "USPixel Component Data Type"},
            {"186050", "ULNumber of Table Break Points"},
            {"186052", "ULTable of X Break Points"},
            {"186054", "FDTable of Y Break Points"},
            {"186056", "ULNumber of Table Entries"},
            {"186058", "ULTable of Pixel Values"},
            {"18605A", "ULTable of Parameter Values"},
            {"187000", "CSDetector Conditions Nominal Flag"},
            {"187001", "DSDetector Temperature"},
            {"187004", "CSDetector Type"},
            {"187005", "CSDetector Configuration"},
            {"187006", "LTDetector Description"},
            {"187008", "LTDetector Mode"},
            {"18700A", "SHDetector ID"},
            {"18700C", "DADate of Last Detector Calibration"},
            {"18700E", "TMTime of Last Detector Calibration"},
            {"187010", "ISExposures on Detector Since Last Calibration"},
            {"187011", "ISExposures on Detector Since Manufactured"},
            {"187012", "DSDetector Time Since Last Exposure"},
            {"187014", "DSDetector Active Time"},
            {"187016", "DSDetector Activation Offset From Exposure"},
            {"18701A", "DSDetector Binning"},
            {"187020", "DSDetector Element Physical Size"},
            {"187022", "DSDetector Element Spacing"},
            {"187024", "CSDetector Active Shape"},
            {"187026", "DSDetector Active Dimension(s)"},
            {"187028", "DSDetector Active Origin"},
            {"187030", "DSField of View Origin"},
            {"187032", "DSField of View Rotation"},
            {"187034", "CSField of View Horizontal Flip"},
            {"187040", "LTGrid Absorbing Material"},
            {"187041", "LTGrid Spacing Material"},
            {"187042", "DSGrid Thickness"},
            {"187044", "DSGrid Pitch"},
            {"187046", "ISGrid Aspect Ratio"},
            {"187048", "DSGrid Period"},
            {"18704C", "DSGrid Focal Distance"},
            {"187050", "LTFilter Material LT"},
            {"187052", "DSFilter Thickness Minimum"},
            {"187054", "DSFilter Thickness Maximum"},
            {"187060", "CSExposure Control Mode"},
            {"187062", "LTExposure Control Mode Description"},
            {"187064", "CSExposure Status"},
            {"187065", "DSPhototimer Setting"},

            {"20000D", "UIStudy Instance UID"},
            {"20000E", "UISeries Instance UID"},
            {"200010", "SHStudy ID"},
            {"200011", "ISSeries Number"},
            {"200012", "ISAcquisition Number"},
            {"200013", "ISImage Number"},
            {"200014", "ISIsotope Number"},
            {"200015", "ISPhase Number"},
            {"200016", "ISInterval Number"},
            {"200017", "ISTime Slot Number"},
            {"200018", "ISAngle Number"},
            {"200020", "CSPatient Orientation"},
            {"200022", "USOverlay Number"},
            {"200024", "USCurve Number"},
            {"200030", "DSImage Position"},
            {"200032", "DSImage Position (Patient)"},
            {"200037", "DSImage Orientation (Patient)"},
            {"200050", "DSLocation"},
            {"200052", "UIFrame of Reference UID"},
            {"200060", "CSLaterality"},
            {"200070", "LOImage Geometry Type"},
            {"200080", "UIMasking Image UID"},
            {"200100", "ISTemporal Position Identifier"},
            {"200105", "ISNumber of Temporal Positions"},
            {"200110", "DSTemporal Resolution"},
            {"201000", "ISSeries in Study"},
            {"201002", "ISImages in Acquisition"},
            {"201004", "ISAcquisition in Study"},
            {"201040", "LOPosition Reference Indicator"},
            {"201041", "DSSlice Location"},
            {"201070", "ISOther Study Numbers"},
            {"201200", "ISNumber of Patient Related Studies"},
            {"201202", "ISNumber of Patient Related Series"},
            {"201204", "ISNumber of Patient Related Images"},
            {"201206", "ISNumber of Study Related Series"},
            {"201208", "ISNumber of Study Related Images"},
            {"204000", "LTImage Comments"},

            {"20500010", "SQPresentation LUT Sequence"},
            {"20500020", "CSPresentation LUT Shape"},
            {"20500500", "SQReferenced Presentation LUT Sequence"},

            {"280002", "USSamples per Pixel"},
            {"280004", "CSPhotometric Interpretation"},
            {"280006", "USPlanar Configuration"},
            {"280008", "ISNumber of Frames"},
            {"280009", "ATFrame Increment Pointer"},
            {"280010", "USRows"},
            {"280011", "USColumns"},
            {"280030", "DSPixel Spacing"},
            {"280031", "DSZoom Factor"},
            {"280032", "DSZoom Center"},
            {"280034", "ISPixel Aspect Ratio"},
            {"280051", "CSCorrected Image"},
            {"280100", "USBits Allocated"},
            {"280101", "USBits Stored"},
            {"280102", "USHigh Bit"},
            {"280103", "USPixel Representation"},
            {"280106", "USSmallest Image Pixel Value"},
            {"280107", "USLargest Image Pixel Value"},
            {"280108", "USSmallest Pixel Value in Series"},
            {"280109", "USLargest Pixel Value in Series"},
            {"280120", "USPixel Padding Value"},
            {"280300", "CSQuality Control Image"},
            {"280301", "CSBurned In Annotation"},
            {"281040", "CSPixel Intensity Relationship"},
            {"281041", "SSPixel Intensity Relationship Sign"},
            {"281050", "DSWindow Center"},
            {"281051", "DSWindow Width"},
            {"281052", "DSRescale Intercept"},
            {"281053", "DSRescale Slope"},
            {"281054", "LORescale Type"},
            {"281055", "LOWindow Center & Width Explanation"},
            {"281101", "USRed Palette Color Lookup Table Descriptor"},
            {"281102", "USGreen Palette Color Lookup Table Descriptor"},
            {"281103", "USBlue Palette Color Lookup Table Descriptor"},
            {"281201", "USRed Palette Color Lookup Table Data"},
            {"281202", "USGreen Palette Color Lookup Table Data"},
            {"281203", "USBlue Palette Color Lookup Table Data"},
            {"282110", "CSLossy Image Compression"},
            {"283000", "SQModality LUT Sequence"},
            {"283002", "USLUT Descriptor"},
            {"283003", "LOLUT Explanation"},
            {"283004", "LOMadality LUT Type"},
            {"283006", "USLUT Data"},
            {"283010", "SQVOI LUT Sequence"},
		
            // Group Tag 3002
            {"30020002", "SHRT Image Label"},
            {"30020003", "LORT Image Name"},
            {"30020004", "STRT Image Description"},
            {"3002000A", "CSReported Values Origin"},
            {"3002000C", "CSRT Image Plane"},
            {"3002000D", "DSX-Ray Image Receptor Translation"},
            {"3002000E", "DSX-Ray Image Receptor Angle"},
            {"30020010", "DSRT Image Orientation"},
            {"30020011", "DSImage Plane Pixel Spacing"},
            {"30020012", "DSRT Image Position"},
            {"30020020", "SHRadiation Machine Name"},
            {"30020022", "DSRadiation Machine SAD"},
            {"30020024", "DSRadiation Machine SSD"},
            {"30020026", "DSRT Image SID"},
            {"30020028", "DSSource to Reference Object Distance"},
            {"30020029", "ISFraction Number"},
            {"30020030", "SQExposure Sequence"},
            {"30020032", "DSMeterset Exposure"},
            {"30020034", "DSDiaphragm Position"},
            {"30020040", "SQFluence Map Sequence"},
            {"30020041", "CSFluence Data Source"},
            {"30020042", "DSFluence Data Scale"},

            // Group Tag 3004
            {"30040001", "CS DVH Type"},
            {"30040002", "CSDose Units"},
            {"30040004", "CSDose Type"},
            {"30040006", "LODose Comment"},
            {"30040008", "DSNormalization Point"},
            {"3004000A", "CSDose Summation Type"},
            {"3004000C", "DSGrid Frame Offset Vector"},
            {"3004000E", "DSDose Grid Scaling"},
            {"30040010", "SQRT Dose ROI Sequence"},
            {"30040012", "DSDose Value"},
            {"30040014", "CSTissue Heterogeneity Correction"},
            {"30040040", "DSDVH Normalization Point"},
            {"30040042", "DSDVH Normalization Dose Value"},
            {"30040050", "SQDVH Sequence"},
            {"30040052", "DSDVH Dose Scaling"},
            {"30040054", "CSDVH Volume Units"},
            {"30040056", "ISDVH Number of Bins"},
            {"30040058", "DSDVH Data"},
            {"30040060", "SQDVH Referenced ROI Sequence"},
            {"30040062", "CSDVH ROI Contribution Type"},
            {"30040070", "DSDVH Minimum Dose"},
            {"30040072", "DSDVH Maximum Dose"},
            {"30040074", "DSDVH Mean Dose"},

            {"32000A", "CSStudy Status ID"},
            {"32000C", "CSStudy Priority ID"},
            {"320012", "LOStudy ID Issuer"},
            {"320032", "DAStudy Verified Date"},
            {"320033", "TMStudy Verified Time"},
            {"320034", "DAStudy Read Date"},
            {"320035", "TMStudy Read Time"},
            {"321000", "DAScheduled Study Start Date"},
            {"321001", "TMScheduled Study Start Time"},
            {"321010", "DAScheduled Study Stop Date"},
            {"321011", "TMScheduled Study Stop Time"},
            {"321020", "LOScheduled Study Location"},
            {"321021", "AEScheduled Study Location AE Title(s)"},
            {"321030", "LOReason for Study"},
            {"321032", "PNRequesting Physician"},
            {"321033", "LORequesting Service"},
            {"321040", "DAStudy Arrival Date"},
            {"321041", "TMStudy Arrival Time"},
            {"321050", "DAStudy Completion Date"},
            {"321051", "TMStudy Completion Time"},
            {"321055", "CSStudy Component Status ID"},
            {"321060", "LORequested Procedure Description"},
            {"321064", "SQRequested Procedure Code Sequence"},
            {"321070", "LORequested Contrast Agent"},
            {"324000", "LTStudy Comments"},

            {"400001", "AEScheduled Station AE Title"},
            {"400002", "DAScheduled Procedure Step Start Date"},
            {"400003", "TMScheduled Procedure Step Start Time"},
            {"400004", "DAScheduled Procedure Step End Date"},
            {"400005", "TMScheduled Procedure Step End Time"},
            {"400006", "PNScheduled Performing Physician's Name"},
            {"400007", "LOScheduled Procedure Step Description"},
            {"400008", "SQScheduled Action Item Code Sequence"},
            {"400009", "SHScheduled Procedure Step ID"},
            {"400010", "SHScheduled Station Name"},
            {"400011", "SHScheduled Procedure Step Location"},
            {"400012", "LOPre-Medication"},
            {"400020", "CSScheduled Procedure Step Status"},
            {"400100", "SQScheduled Procedure Step Sequence"},
            {"400220", "SQReferenced Standalone SOP Instance Sequence"},
            {"400241", "AEPerformed Station AE Title"},
            {"400242", "SHPerformed Station Name"},
            {"400243", "SHPerformed Location"},
            {"400244", "DAPerformed Procedure Step Start Date"},
            {"400245", "TMPerformed Procedure Step Start Time"},
            {"400250", "DAPerformed Procedure Step End Date"},
            {"400251", "TMPerformed Procedure Step End Time"},
            {"400252", "CSPerformed Procedure Step Status"},
            {"400253", "SHPerformed Procedure Step ID"},
            {"400254", "LOPerformed Procedure Step Description"},
            {"400255", "LOPerformed Procedure Type Description"},
            {"400260", "SQPerformed Action Item Sequence"},
            {"400270", "SQScheduled Step Attributes Sequence"},
            {"400275", "SQRequest Attributes Sequence"},
            {"400280", "STComments on the Performed Procedure Steps"},
            {"400293", "SQQuantity Sequence"},
            {"400294", "DSQuantity"},
            {"400295", "SQMeasuring Units Sequence"},
            {"400296", "SQBilling Item Sequence"},
            {"400300", "USTotal Time of Fluoroscopy"},
            {"400301", "USTotal Number of Exposures"},
            {"400302", "USEntrance Dose"},
            {"400303", "USExposed Area"},
            {"400306", "DSDistance Source to Entrance"},
            {"400307", "DSDistance Source to Support"},
            {"400310", "STComments on Radiation Dose"},
            {"400312", "DSX-Ray Output"},
            {"400314", "DSHalf Value Layer"},
            {"400316", "DSOrgan Dose"},
            {"400318", "CSOrgan Exposed"},
            {"400320", "SQBilling Procedure Step Sequence"},
            {"400321", "SQFilm Consumption Sequence"},
            {"400324", "SQBilling Supplies and Devices Sequence"},
            {"400330", "SQReferenced Procedure Step Sequence"},
            {"400340", "SQPerformed Series Sequence"},
            {"400400", "LTComments on the Scheduled Procedure Step"},
            {"40050A", "LOSpecimen Accession Number"},
            {"400550", "SQSpecimen Sequence"},
            {"400551", "LOSpecimen Identifier"},
            {"40059A", "SQSpecimen Type Code Sequence"},
            {"400555", "SQAcquisition Context Sequence"},
            {"400556", "STAcquisition Context Description"},
            {"4006FA", "LOSlide Identifier"},
            {"40071A", "SQImage Center Point Coordinates Sequence"},
            {"40072A", "DSX offset in Slide Coordinate System"},
            {"40073A", "DSY offset in Slide Coordinate System"},
            {"40074A", "DSZ offset in Slide Coordinate System"},
            {"4008D8", "SQPixel Spacing Sequence"},
            {"4008DA", "SQCoordinate System Axis Code Sequence"},
            {"4008EA", "SQMeasurement Units Code Sequence"},
            {"401001", "SHRequested Procedure ID"},
            {"401002", "LOReason for the Requested Procedure"},
            {"401003", "SHRequested Procedure Priority"},
            {"401004", "LOPatient Transport Arrangements"},
            {"401005", "LORequested Procedure Location"},
            {"401006", " 1Placer Order Number / Procedure S"},
            {"401007", " 1Filler Order Number / Procedure S"},
            {"401008", "LOConfidentiality Code"},
            {"401009", "SHReporting Priority"},
            {"401010", "PNNames of Intended Recipients of Results"},
            {"401400", "LTRequested Procedure Comments"},
            {"402001", "LOReason for the Imaging Service Request"},
            {"402004", "DAIssue Date of Imaging Service Request"},
            {"402005", "TMIssue Time of Imaging Service Request"},
            {"402006", " 1Placer Order Number / Imaging Service Request S"},
            {"402007", " 1Filler Order Number / Imaging Service Request S"},
            {"402008", "PNOrder Entered By"},
            {"402009", "SHOrder Enterers Location"},
            {"402010", "SHOrder Callback Phone Number"},
            {"402016", "LOPlacer Order Number / Imaging Service Request"},
            {"402017", "LOFiller Order Number / Imaging Service Request"},
            {"402400", "LTImaging Service Request Comments"},
            {"403001", "LOConfidentiality Constraint on Patient Data Description"},
            {"408302", "DSEntrance Dose in mGy"},
            {"40A010", "CSRelationship Type"},
            {"40A027", "LOVerifying Organization"},
            {"40A030", "DTVerification DateTime"},
            {"40A032", "DTObservation DateTime"},
            {"40A040", "CSValue Type"},
            {"40A043", "SQConcept-name Code Sequence"},
            {"40A050", "CSContinuity Of Content"},
            {"40A073", "SQVerifying Observer Sequence"},
            {"40A075", "PNVerifying Observer Name"},
            {"40A088", "SQVerifying Observer Identification Code Sequence"},
            {"40A0B0", "USReferenced Waveform Channels"},
            {"40A120", "DTDateTime"},
            {"40A121", "DADate"},
            {"40A122", "TMTime"},
            {"40A123", "PNPerson Name"},
            {"40A124", "UIUID"},
            {"40A130", "CSTemporal Range Type"},
            {"40A132", "ULReferenced Sample Positions"},
            {"40A136", "USReferenced Frame Numbers"},
            {"40A138", "DSReferenced Time Offsets"},
            {"40A13A", "DTReferenced Datetime"},
            {"40A160", "UTText Value"},
            {"40A168", "SQConcept Code Sequence"},
            {"40A180", "USAnnotation Group Number"},
            {"40A195", "SQModifier Code Sequence"},
            {"40A300", "SQMeasured Value Sequence"},
            {"40A30A", "DSNumeric Value"},
            {"40A360", "SQPredecessor Documents Sequence"},
            {"40A370", "SQReferenced Request Sequence"},
            {"40A372", "SQPerformed Procedure Code Sequence"},
            {"40A375", "SQCurrent Requested Procedure Evidence Sequence"},
            {"40A385", "SQPertinent Other Evidence Sequence"},
            {"40A491", "CSCompletion Flag"},
            {"40A492", "LOCompletion Flag Description"},
            {"40A493", "CSVerification Flag"},
            {"40A504", "SQContent Template Sequence"},
            {"40A525", "SQIdentical Documents Sequence"},
            {"40A730", "SQContent Sequence"},
            {"40B020", "SQAnnotation Sequence"},
            {"40DB00", "CSTemplate Identifier"},
            {"40DB06", "DTTemplate Version"},
            {"40DB07", "DTTemplate Local Version"},
            {"40DB0B", "CSTemplate Extension Flag"},
            {"40DB0C", "UITemplate Extension Organization UID"},
            {"40DB0D", "UITemplate Extension Creator UID"},
            {"40DB73", "ULReferenced Content Item Identifier"},

            {"540011", "USNumber of Energy Windows"},
            {"540012", "SQEnergy Window Information Sequence"},
            {"540013", "SQEnergy Window Range Sequence"},
            {"540014", "DSEnergy Window Lower Limit"},
            {"540015", "DSEnergy Window Upper Limit"},
            {"540016", "SQRadiopharmaceutical Information Sequence"},
            {"540017", "ISResidual Syringe Counts"},
            {"540018", "SHEnergy Window Name"},
            {"540020", "USDetector Vector"},
            {"540021", "USNumber of Detectors"},
            {"540022", "SQDetector Information Sequence"},
            {"540030", "USPhase Vector"},
            {"540031", "USNumber of Phases"},
            {"540032", "SQPhase Information Sequence"},
            {"540033", "USNumber of Frames in Phase"},
            {"540036", "ISPhase Delay"},
            {"540038", "ISPause Between Frames"},
            {"540039", "CSPhase Description"},
            {"540050", "USRotation Vector"},
            {"540051", "USNumber of Rotations"},
            {"540052", "SQRotation Information Sequence"},
            {"540053", "USNumber of Frames in Rotation"},
            {"540060", "USR-R Interval Vector"},
            {"540061", "USNumber of R-R Intervals"},
            {"540062", "SQGated Information Sequence"},
            {"540063", "SQData Information Sequence"},
            {"540070", "USTime Slot Vector"},
            {"540071", "USNumber of Time Slots"},
            {"540072", "SQTime Slot Information Sequence"},
            {"540073", "DSTime Slot Time"},
            {"540080", "USSlice Vector"},
            {"540081", "USNumber of Slices"},
            {"540090", "USAngular View Vector"},
            {"540100", "USTime Slice Vector"},
            {"540101", "USNumber of Time Slices"},
            {"540200", "DSStart Angle"},
            {"540202", "CSType of Detector Motion"},
            {"540210", "ISTrigger Vector"},
            {"540211", "USNumber of Triggers in Phase"},
            {"540220", "SQView Code Sequence"},
            {"540222", "SQView Modifier Code Sequence"},
            {"540300", "SQRadionuclide Code Sequence"},
            {"540302", "SQAdministration Route Code Sequence"},
            {"540304", "SQRadiopharmaceutical Code Sequence"},
            {"540306", "SQCalibration Data Sequence"},
            {"540308", "USEnergy Window Number"},
            {"540400", "SHImage ID"},
            {"540410", "SQPatient Orientation Code Sequence"},
            {"540412", "SQPatient Orientation Modifier Code Sequence"},
            {"540414", "SQPatient Gantry Relationship Code Sequence"},
            {"540500", "CSSlice Progression Direction"},
            {"541000", "CSSeries Type"},
            {"541001", "CSUnits"},
            {"541002", "CSCounts Source"},
            {"541004", "CSReprojection Method"},
            {"541100", "CSRandoms Correction Method"},
            {"541101", "LOAttenuation Correction Method"},
            {"541102", "CSDecay Correction"},
            {"541103", "LOReconstruction Method"},
            {"541104", "LODetector Lines of Response Used"},
            {"541105", "LOScatter Correction Method"},
            {"541200", "DSAxial Acceptance"},
            {"541201", "ISAxial Mash"},
            {"541202", "ISTransverse Mash"},
            {"541203", "DSDetector Element Size"},
            {"541210", "DSCoincidence Window Width"},
            {"541220", "CSSecondary Counts Type"},
            {"541300", "DSFrame Reference Time"},
            {"541310", "ISPrimary (Prompts) Counts Accumulated"},
            {"541311", "ISSecondary Counts Accumulated"},
            {"541320", "DSSlice Sensitivity Factor"},
            {"541321", "DSDecay Factor"},
            {"541322", "DSDose Calibration Factor"},
            {"541323", "DSScatter Fraction Factor"},
            {"541324", "DSDead Time Factor"},
            {"541330", "USImage Index"},
            {"541400", "CSCounts Included"},
            {"541401", "CSDead Time Correction Flag"},
        
            {"7FE00010", "OXPixel Data"}, // Represents OB or OW type of VR

            {"FFFEE000", "DLItem"},
            {"FFFEE00D", "DLItem Delimitation Item"},
            {"FFFEE0DD", "DLSequence Delimitation Item"} 
        };
    }
}